## mingw-w64-qt6-grpc-6.9.0-3.src.tar.zst

=== CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

include(.cmake.conf)
project(QtGrpc
    VERSION "${QT_REPO_MODULE_VERSION}"
    DESCRIPTION "Qt GRPC and Protobuf generator and bindings."
    HOMEPAGE_URL "https://qt.io"
    LANGUAGES CXX C
)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals Core)
# Try to find Qt6::qtprotobufgen and Qt6::qtgrpcgen targets from host tools
# when cross-compiling.
if(NOT "${QT_HOST_PATH}" STREQUAL "")
    add_subdirectory("${CMAKE_CURRENT_LIST_DIR}/src/tools/host")
endif()

find_package(Qt6 ${PROJECT_VERSION} CONFIG OPTIONAL_COMPONENTS Network Gui Widgets Quick
    QmlNetwork QuickControls2 QuickTest)
qt_internal_project_setup()

include("${CMAKE_CURRENT_LIST_DIR}/src/tools/qtprotobufgen/Qt6ProtobufToolsMacros.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/src/tools/qtgrpcgen/Qt6GrpcToolsMacros.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/src/protobuf/Qt6ProtobufBuildInternals.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/src/wellknown/Qt6ProtobufWellKnownTypesBuildInternals.cmake")

qt_build_repo()

=== src/tools/qtprotoccommon/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_add_library(QtProtocCommon STATIC
    qtprotocdefs.h
    baseprinter.cpp baseprinter.h
    descriptorprinterbase.h
    generatorbase.cpp generatorbase.h
    generatorcommon.cpp generatorcommon.h
    options.cpp options.h
    commontemplates.cpp commontemplates.h
    utils.cpp utils.h
)

target_link_libraries(QtProtocCommon
    PUBLIC
        protobuf::libprotobuf
        protobuf::libprotoc
)

target_include_directories(QtProtocCommon PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

=== examples/grpc/chat/client/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.18)
project(qtgrpc_chat_client LANGUAGES CXX)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()
set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/grpc/chat")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(GRPC_CHAT_USE_EMOJI_FONT "Enable emoji font support" OFF)

find_package(Qt6 REQUIRED
    COMPONENTS
        Core
        Gui
        Qml
        Quick
        QuickControls2
        Protobuf
        ProtobufQtCoreTypes
        ProtobufQuick
        Grpc
        GrpcQuick
)
qt_standard_project_setup(REQUIRES 6.9)

qt_add_executable(qtgrpc_chat_client WIN32 MACOSX_BUNDLE main.cpp)
qt_add_qml_module(qtgrpc_chat_client
    URI QtGrpcChat
    VERSION 1.0
    QML_FILES
        Main.qml
        ChatView.qml
        LoginView.qml
        StatusDisplay.qml
        ChatMessages/FileContinuationDelegate.qml
        ChatMessages/FileDelegate.qml
        ChatMessages/ImageDelegate.qml
        ChatMessages/TextDelegate.qml
        ChatMessages/UserStatusDelegate.qml
    RESOURCES
        res/send.svg
        res/generic_file.svg
        res/attach.svg
    SOURCES
        chatengine.h chatengine.cpp
        clientworker.h clientworker.cpp
        userstatusmodel.h userstatusmodel.cpp
        chatmessagemodel.h chatmessagemodel.cpp
)

qt_add_resources(qtgrpc_chat_client "resources"
    FILES
        res/root.crt
        res/qtchat_logo.png
)

if(GRPC_CHAT_USE_EMOJI_FONT)
    set(font_path "${CMAKE_CURRENT_BINARY_DIR}/downloads/NotoColorEmoji.ttf")

    if(NOT EXISTS "${font_path}")
        file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/downloads")
        set(font_url "https://github.com/googlefonts/noto-emoji/raw/main/fonts/NotoColorEmoji.ttf")
        file(DOWNLOAD ${font_url} ${font_path} SHOW_PROGRESS)
    endif()

    set_source_files_properties(${font_path} PROPERTIES QT_RESOURCE_ALIAS "NotoColorEmoji.ttf")
    qt_add_resources(qtgrpc_chat_client "font"
        FILES
            "${font_path}"
    )
    target_compile_definitions(qtgrpc_chat_client PRIVATE USE_EMOJI_FONT)
endif()

#! [client-setup-1]
add_library(qtgrpc_chat_client_proto STATIC)
qt_add_protobuf(qtgrpc_chat_client_proto
    QML
    QML_URI QtGrpcChat.Proto
    PROTO_FILES
        ../proto/chatmessages.proto
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufQtCoreTypes,QT_PROTO_INCLUDES>
)

qt_add_grpc(qtgrpc_chat_client_proto CLIENT
    PROTO_FILES
        ../proto/qtgrpcchat.proto
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufQtCoreTypes,QT_PROTO_INCLUDES>
)
#! [client-setup-1]

if(ANDROID)
    set_target_properties(qtgrpc_chat_client
        PROPERTIES
            QT_ANDROID_PACKAGE_SOURCE_DIR "${CMAKE_CURRENT_LIST_DIR}/android"
            QT_ANDROID_PACKAGE_NAME "org.qtproject.grpc.chat"
            QT_ANDROID_APP_NAME "QtGrpcChat"
            QT_ANDROID_APP_ICON "@drawable/icon"
    )

    include(FetchContent)
    FetchContent_Declare(
        android_openssl
        DOWNLOAD_EXTRACT_TIMESTAMP true
        URL https://github.com/KDAB/android_openssl/archive/refs/heads/master.zip
    )
    FetchContent_MakeAvailable(android_openssl)
    include(${android_openssl_SOURCE_DIR}/android_openssl.cmake)
    add_android_openssl_libraries(qtgrpc_chat_client)
endif()

#! [client-setup-2]
target_link_libraries(qtgrpc_chat_client_proto
    PUBLIC
        Qt6::Protobuf
        Qt6::ProtobufQtCoreTypes
        Qt6::Grpc
)
#! [client-setup-2]

target_link_libraries(qtgrpc_chat_client
    PRIVATE
        Qt6::Core
        Qt6::Gui
        Qt6::Qml
        qtgrpc_chat_client_proto
)

install(TARGETS qtgrpc_chat_client qtgrpc_chat_client_proto
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

qt_generate_deploy_qml_app_script(
    TARGET qtgrpc_chat_client
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

if(TARGET qtgrpc_chat_server)
    add_dependencies(qtgrpc_chat_client qtgrpc_chat_server)
endif()

=== tests/manual/grpc/benchmarks/asyncbenchserver/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)

find_package(Protobuf)
find_package(gRPC)

if(NOT TARGET gRPC::grpc_cpp_plugin OR NOT TARGET WrapProtoc::WrapProtoc
    OR NOT TARGET gRPC::grpc++)
    message(WARNING "Dependencies of QtGrpc benchmark-server not found. Skipping.")
    return()
endif()

set(proto_out_dir "${CMAKE_CURRENT_BINARY_DIR}/include/proto/")
set(proto_out_include "${CMAKE_CURRENT_BINARY_DIR}/include/")

set(generated_files
    "${proto_out_dir}/bench.grpc.pb.h"
    "${proto_out_dir}/bench.grpc.pb.cc"
    "${proto_out_dir}/bench.pb.h"
    "${proto_out_dir}/bench.pb.cc"
)

set(extra_protoc_args "")
get_target_property(protoc_version WrapProtoc::WrapProtoc _qt_internal_protobuf_version)
if(protoc_version VERSION_GREATER_EQUAL "3.12" AND protoc_version VERSION_LESS "3.15")
    list(APPEND extra_protoc_args "--experimental_allow_proto3_optional")
endif()

add_custom_command(
    OUTPUT ${generated_files}
    COMMAND
        $<TARGET_FILE:WrapProtoc::WrapProtoc>
    ARGS
        "${extra_protoc_args}"
        --grpc_out "${proto_out_dir}"
        --cpp_out "${proto_out_dir}"
        -I "${proto_include}"
        --plugin=protoc-gen-grpc=$<TARGET_FILE:gRPC::grpc_cpp_plugin>
        "${proto_path}"
    WORKING_DIRECTORY "${proto_out_dir}"
    DEPENDS
        "${proto_path}"
        $<TARGET_FILE:WrapProtoc::WrapProtoc>
        $<TARGET_FILE:gRPC::grpc_cpp_plugin>
    COMMENT "Generating gRPC ${target} sources..."
    COMMAND_EXPAND_LISTS
    VERBATIM
)

set_source_files_properties(${generated_files} PROPERTIES GENERATED TRUE)

qt_internal_add_executable(
    asyncbenchserver
    SOURCES
        asyncbenchserver.cpp
        "${generated_files}"
    LIBRARIES
        protobuf::libprotobuf
        gRPC::grpc++
    INCLUDE_DIRECTORIES
        "${proto_out_include}"
        "${qrpcbench_common_include}"
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}"
)

=== tests/auto/grpc/client/shared/test_server/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)

find_package(Protobuf)
find_package(gRPC)

if(NOT TARGET gRPC::grpc_cpp_plugin OR NOT TARGET WrapProtoc::WrapProtoc
    OR NOT TARGET gRPC::grpc++)
    message(WARNING "Dependencies of Qt GRPC test server not found. Skipping.")
    return()
endif()

set(proto_files "${CMAKE_CURRENT_LIST_DIR}/../../../shared/proto/testservice.proto")
set(out_dir ${CMAKE_CURRENT_BINARY_DIR})

set(generated_files
    "${out_dir}/testservice.pb.h" "${out_dir}/testservice.pb.cc"
    "${out_dir}/testservice.grpc.pb.h" "${out_dir}/testservice.grpc.pb.cc")

set(extra_protoc_args "")
get_target_property(protoc_version WrapProtoc::WrapProtoc _qt_internal_protobuf_version)
if(protoc_version VERSION_GREATER_EQUAL "3.12" AND protoc_version VERSION_LESS "3.15")
    list(APPEND extra_protoc_args "--experimental_allow_proto3_optional")
endif()

add_custom_command(
    OUTPUT ${generated_files}
    COMMAND
        $<TARGET_FILE:WrapProtoc::WrapProtoc>
    ARGS
        ${extra_protoc_args}
        --grpc_out "${out_dir}"
        --cpp_out "${out_dir}"
        -I "${CMAKE_CURRENT_LIST_DIR}/../../../shared/proto/"
        --plugin=protoc-gen-grpc=$<TARGET_FILE:gRPC::grpc_cpp_plugin>
        "${proto_files}"
    WORKING_DIRECTORY ${out_dir}
    DEPENDS "${proto_files}" $<TARGET_FILE:WrapProtoc::WrapProtoc>
    COMMENT "Generating gRPC ${target} sources..."
    COMMAND_EXPAND_LISTS
    VERBATIM
)

set_source_files_properties(${generated_files} PROPERTIES GENERATED TRUE)
add_library(grpc_testserverrunner_gen STATIC ${generated_files})
target_include_directories(grpc_testserverrunner_gen
    PRIVATE
        ${out_dir}
        WrapgRPC_INCLUDE_PATH
)

target_link_libraries(grpc_testserverrunner_gen
    PRIVATE
        protobuf::libprotobuf
        gRPC::grpc++
)

add_library(grpc_testserverrunner
    STATIC
        ${CMAKE_CURRENT_LIST_DIR}/testserverrunner.cpp
        ${CMAKE_CURRENT_LIST_DIR}/testserverrunner.h
)

target_include_directories(grpc_testserverrunner
    PRIVATE
        ${out_dir}
        ${CMAKE_CURRENT_LIST_DIR}/../../../shared
)

target_link_libraries(grpc_testserverrunner
    PRIVATE
        grpc_testserverrunner_gen
        gRPC::grpc++
        Qt6::Core
)

set_source_files_properties("${CMAKE_CURRENT_LIST_DIR}/assets/cert.pem"
    PROPERTIES QT_RESOURCE_ALIAS assets/cert.pem)
set_source_files_properties("${CMAKE_CURRENT_LIST_DIR}/assets/key.pem"
    PROPERTIES QT_RESOURCE_ALIAS assets/key.pem)

qt_add_resources(grpc_testserverrunner
    "keys"
    PREFIX
        "/"
    FILES
        "${CMAKE_CURRENT_LIST_DIR}/assets/cert.pem"
        "${CMAKE_CURRENT_LIST_DIR}/assets/key.pem"
)

qt_internal_add_executable(grpc_testserver
    SOURCES
        ${CMAKE_CURRENT_LIST_DIR}/testserver.cpp
    LIBRARIES
        grpc_testserverrunner
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/"
    INSTALL_DIRECTORY "${INSTALL_TESTSDIR}/shared"
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-grpc
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.9.0
pkgver=${_qtver/-/}
pkgrel=3
pkgdesc='Qt gRPC and Protobuf generator and bindings. (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgrpc.git"
msys2_references=(
  'archlinux: qt6-grpc'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-grpc"
             "${MINGW_PACKAGE_PREFIX}-protobuf"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        "https://github.com/qt/qtgrpc/commit/514769d1bd595d0e54bbe34c0bd167636d4825dc.patch")
sha256sums=('3957e076181ac0d9a8f9fca93ec49e1e5e143e39eee1ec3feee10ca13f64b137'
            '3945b9d021b3e02fc532a03b1efe3fab9738973fd2c2aca36d3904cbbb66f834')

prepare() {
  cd "${_pkgfn}"

  patch -p1 -i ../514769d1bd595d0e54bbe34c0bd167636d4825dc.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-grpc() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-abseil-cpp"
           "${MINGW_PACKAGE_PREFIX}-grpc"
           "${MINGW_PACKAGE_PREFIX}-protobuf"
           "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-grpc-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
